package com.xzzn.ems.mapper;

import java.util.List;
import com.xzzn.ems.domain.EmsAlarmRecords;
import com.xzzn.ems.domain.vo.*;
import org.apache.ibatis.annotations.Param;

/**
 * 告警记录Mapper接口
 *
 * @author xzzn
 * @date 2025-06-17
 */
public interface EmsAlarmRecordsMapper
{
    /**
     * 查询告警记录
     *
     * @param id 告警记录主键
     * @return 告警记录
     */
    public EmsAlarmRecords selectEmsAlarmRecordsById(Long id);

    /**
     * 查询告警记录列表
     *
     * @param emsAlarmRecords 告警记录
     * @return 告警记录集合
     */
    public List<EmsAlarmRecords> selectEmsAlarmRecordsList(EmsAlarmRecords emsAlarmRecords);

    /**
     * 新增告警记录
     *
     * @param emsAlarmRecords 告警记录
     * @return 结果
     */
    public int insertEmsAlarmRecords(EmsAlarmRecords emsAlarmRecords);

    /**
     * 修改告警记录
     *
     * @param emsAlarmRecords 告警记录
     * @return 结果
     */
    public int updateEmsAlarmRecords(EmsAlarmRecords emsAlarmRecords);

    /**
     * 删除告警记录
     *
     * @param id 告警记录主键
     * @return 结果
     */
    public int deleteEmsAlarmRecordsById(Long id);

    /**
     * 批量删除告警记录
     *
     * @param ids 需要删除的数据主键集合
     * @return 结果
     */
    public int deleteEmsAlarmRecordsByIds(Long[] ids);

    /**
     * 根据站点id获取告警记录
     *
     */
    public List<SiteMonitorHomeAlarmVo> getAlarmRecordsBySiteId(String siteId);

    /**
     * 获取告警趋势数据
     *
     */
    public List<AlarmTrendList> getAlarmTrendList();

    /**
     * 获取设备告警占比
     *
     */
    public List<DeviceAlarmProportionList> getDeviceAlarmPropList();

    /**
     * 获取设备等级分布
     *
     */
    public List<AlarmGradeList> getAlarmGradeList();


    public List<AlarmRecordListResponseVo> getAlarmRecordDetailList(AlarmRecordListRequestVo requestVo);

    // 获取站点设备告警数量
    public int getDeviceAlarmNum(@Param("siteId") String siteId, @Param("deviceId") String deviceId);

    //获取未处理的订阅失败告警
    public EmsAlarmRecords getFailedRecord(@Param("siteId")String siteId,
                                           @Param("content") String content,
                                           @Param("level")String level);

    // 批量处理告警数据
    public void batchUpsert(@Param("recordsList")List<EmsAlarmRecords> recordsList);

    // 获取所有没有处理完成的告警记录
    public List<EmsAlarmRecords> getAllUnfinishedRecords(@Param("needUpdateKeys")List<String> needUpdateKeys,@Param("siteId") String siteId,
                                                         @Param("deviceId") String deviceId);

    // 根据ticketNo更新告警状态
    public EmsAlarmRecords getAlarmByTicketNo(@Param("ticketNo")String ticketNo);
    //获取指定设备未处理和处理中的告警
    public List<EmsAlarmRecords> getNeedPutRedisAlarm(@Param("siteId")String siteId, @Param("deviceId")String deviceId);
}
